//+------------------------------------------------------------------+
//|                                                  4Hour-GL_EA.mq4 |
//|                                                            23510 |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "23510"
#property link      ""
extern double  TakeProfit              =    100;  // TP
extern double  StopLoss                =    250;  // SL
extern double  LotSize                 =    0.1;  // Lots size
extern double  TrailingStop            =     80;  // to disable trainiling stop set it to 3000
extern int     RSI                     =     21;  // RSI value 
extern int     START_HOUR              =      4;  // start trading
extern int     END_HOUR                =     20;  // stop trading
extern int     ENTRY_DIST              =     10;  // Distance from high or low of candle to enter a trade order
extern int     Magic                   = 709090;  // Magic number
extern int     Entry_Distance          =     10;  // Distance price must be from the high/low of a candle to enter the trade

double sema,lema,mpl,rsi,jaws,teeth,lips;
int ticket,cnt,total;
bool buy,sell;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
   run_indies();
   filter();
   trade();
   return(0);
  }
//+------------------------------------------------------------------+

void run_indies()
{
//////////////////
   sema     = iMA(NULL,0,89,0,MODE_EMA,PRICE_CLOSE,0);    // 89 EMA
   lema     = iMA(NULL,0,200,0,MODE_EMA,PRICE_CLOSE,0);   // 200 EMA
   mpl      = iCustom(NULL,0,"MPi-TL",5,0.618,0,0);       // Custom MPi-TL indicator
   rsi      = iRSI(Symbol(),0,RSI,PRICE_CLOSE,0);         // RSI
 //  jaws     = iAlligator(Symbol(),0,Jaw_Period,Jaw_shift,Teeth_Period,Teeth_Shift,Lips_Period,Lips_shift,0,PRICE_CLOSE,MODE_GATORJAW);
 //  teeth    = iAlligator(Symbol(),0,Jaw_Period,Jaw_shift,Teeth_Period,Teeth_Shift,Lips_Period,Lips_shift,0,PRICE_CLOSE,MODE_GATORTEETH);
 //  lips     = iAlligator(Symbol(),0,Jaw_Period,Jaw_shift,Teeth_Period,Teeth_Shift,Lips_Period,Lips_shift,0,PRICE_CLOSE,MODE_GATORLIPS);
//////////////////
}
//+-------------------------------------------------------------------+
void trade()
{
total =OrdersTotal();
////////////////////
double sll    = Low[iLowest(NULL,PERIOD_W1,MODE_LOW,2,1)];  //iLow(Symbol(),PERIOD_W1,iLowest(Symbol(),PERIOD_W1,MODE_LOW,2,1));   // Low[iLowest(NULL,PERIOD_W1,MODE_LOW,2,0)];    
double sls    = High[iHighest(NULL,PERIOD_W1,MODE_HIGH,2,1)]; //iHigh(Symbol(),PERIOD_W1,iHighest(Symbol(),PERIOD_W1,MODE_HIGH,2,1));
double slla   = sll-10*Point;
double fsll   = NormalizeDouble(slla,Digits); // O-S 
double slsa   = sls+10*Point;
double fsls   = NormalizeDouble(slsa,Digits); // O-S
//----TP Settings
   double entry  = OrderOpenPrice(); 
//////////////////// 
   double tpl    = (entry-sll);           
   double tpl2   =  tpl*0.618;
   double tpl3   = entry+tpl2;   
   double ftpl   = NormalizeDouble(tpl3,Digits); // O-S
//------------------------------------->   
   double tps    = (sls-entry);    
   double tps2   = tps*0.618;
   double tps3   = entry-tps2;  
   double ftps   = NormalizeDouble(tps3,Digits); // O-S    
//------------------------------------->
////////////////////
if(total<1&&buy==true)

{
RefreshRates();
ticket = OrderSend(Symbol(),OP_BUY,LotSize,Ask,3,fsll,ftpl,"4HR-GL",Magic,0,Green); //Ask+TakeProfit*Point , Ask-StopLoss*Point
if(ticket>0)
           {
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("BUY order opened : ",OrderOpenPrice());
           }
         else Print("Error opening BUY order : ",GetLastError()); 
         return(0); 
         }
////////////////////
if(total<1&&sell==true)
{
RefreshRates();
ticket = OrderSend(Symbol(),OP_SELL,LotSize,Bid,3,fsls,ftps,"4HR-GL",Magic,0,Red); //Bid-TakeProfit*Point , Bid+stopLoss*Point
if(ticket>0)
           {
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("SELL order opened : ",OrderOpenPrice());
           }
         else Print("Error opening SELL order : ",GetLastError()); 
         return(0); 
         }         
////////////////////
}

void filter()
{
////////////////////
//Entry points
  double entlong = iHighest(Symbol(),0,MODE_HIGH,2,0)+Entry_Distance*Point; // Must enter trades 10 pips from hig or low //
  double entshort = iLowest(Symbol(),0,MODE_LOW,2,0)-Entry_Distance*Point; 
///////////////////////------------------>

///////////////////
if(Close[1]>mpl)buy=true;
if(Close[2]<mpl)buy=false;
if(rsi<50)buy=false;
//if(Bid>=entlong)buy=true; // put this in once all is working

/////////////////////////////
if(Close[1]<mpl)sell=true;
if(Close[2]>mpl)sell=false;
if(rsi>50)sell=false;
//if(Bid<=entshort)sell=true; // put this in once all is working

////////////////////
}